/* sf11d.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__11 = 11;

doublereal sf11d_c(doublereal *x, integer *l, integer *ierr)
{
    /* Initialized data */

    static doublereal sys059 = 1.7e308;
    static doublereal xmax = 177.85567464849;
    static doublereal one = 1.;
    static doublereal zero = 0.;
    static doublereal sys073 = 2.2227587494851e-162;
    static doublereal sys061 = 2.23e-308;
    static doublereal p[5] = { .1203176761421961,24.99784339185733,
            1797.13456510212,44333.31008786754,179847.3001635515 };
    static doublereal q[4] = { .25,-70.35978938634682,9316.074668016924,
            -553734.3719560826 };
    static doublereal f[5] = { .00210761874039124,.4076347371250282,
            30.92138338821924,951.7918567206316,8501.049475393063 };
    static doublereal g[2] = { -221.6786554069839,17002.09895078612 };
    static doublereal pp[10] = { .06982646013142393,6.943429490437559,
            101.624513525677,519.0226276746315,1207.119908800295,
            1430.398225341416,900.5826147591565,298.6452400790679,
            48.33007694228657,2.958171781643913 };
    static doublereal qq[8] = { 30.17103765395105,228.1150283978967,
            673.0124200199513,924.6057876003073,638.5720888284594,
            224.4322524683622,37.67671736737388,2.360279592776385 };

    /* System generated locals */
    doublereal ret_val;

    /* Builtin functions */
    double exp(doublereal), log(doublereal), sqrt(doublereal);

    /* Local variables */
    static doublereal sumf, sumg, sump, sumq, a;
    static integer i__;
    extern /* Subroutine */ int utsf11_c(integer *, integer *);
    static doublereal xx;

    *ierr = 0;
    if (*x < sys061) {
        goto L8;
    }
    a = one;
    if (*l != 1 && *l != 2) {
        goto L10;
    }
    switch (*l) {
        case 1:  goto L1;
        case 2:  goto L2;
    }
L1:
    if (*x > xmax) {
        goto L9;
    }
    if (*x <= one) {
        goto L3;
    }
    a = exp(-(*x));
    goto L5;
L2:
    if (*x > one) {
        goto L5;
    }
    a = exp(*x);
L3:
    if (*x < sys073) {
        goto L4;
    }
    xx = *x * *x;
    sump = ((((p[0] * xx + p[1]) * xx + p[2]) * xx + p[3]) * xx + p[4]) * xx 
            + q[3];
    sumq = ((q[0] * xx + q[1]) * xx + q[2]) * xx + q[3];
    sumf = (((f[0] * xx + f[1]) * xx + f[2]) * xx + f[3]) * xx + f[4];
    sumg = (xx + g[0]) * xx + g[1];
    ret_val = (xx * log(*x) * sumf / sumg + sump / sumq) / *x * a;
    goto L12;
L4:
    ret_val = one / *x;
    goto L12;
L5:
    xx = one / *x;
    sump = pp[0];
    for (i__ = 2; i__ <= 10; ++i__) {
        sump = sump * xx + pp[i__ - 1];
/* L6: */
    }
    sumq = xx;
    for (i__ = 1; i__ <= 7; ++i__) {
        sumq = (sumq + qq[i__ - 1]) * xx;
/* L7: */
    }
    sumq += qq[7];
    ret_val = a * sump / sumq / sqrt(*x);
    goto L12;
L8:
    *ierr = 66;
    ret_val = sys059;
    goto L11;
L9:
    *ierr = 67;
    ret_val = zero;
    goto L11;
L10:
    ret_val = sys059;
    *ierr = 65;
L11:
    utsf11_c(ierr, &c__11);
L12:
    return ret_val;
} /* sf11d_c */
